# strchr

From cppreference.com
< c‎ | string‎ | byte

Defined in header `<string.h>` |  |
char *strchr( const char *str, int ch ); |  |

Finds the first occurrence of `ch` (after conversion to char as if by (char)ch) in the null-terminated byte string pointed to by `str` (each character interpreted as unsigned char). The terminating null character is considered to be a part of the string and can be found when searching for '\0'.

The behavior is undefined if `str` is not a pointer to a null-terminated byte string.

### Parameters

str | - | pointer to the null-terminated byte string to be analyzed
ch | - | character to search for

### Return value

Pointer to the found character in `str`, or null pointer if no such character is found.

### Example

Run this code

    #include <stdio.h>
    #include <string.h>

    int main(void)
    {
      const char *str = "Try not. Do, or do not. There is no try.";
      char target = 'T';
      const char *result = str;

      while((result = strchr(result, target)) != NULL) {
        printf("Found '%c' starting at '%s'\n", target, result);
        ++result; // Increment result, otherwise we'll find target at the same location
      }
    }

Output:

    Found 'T' starting at 'Try not. Do, or do not. There is no try.'
    Found 'T' starting at 'There is no try.'

### References

- C11 standard (ISO/IEC 9899:2011):

  - 7.24.5.2 The strchr function (p: 367-368)

- C99 standard (ISO/IEC 9899:1999):

  - 7.21.5.2 The strchr function (p: 330)

- C89/C90 standard (ISO/IEC 9899:1990):

  - 4.11.5.2 The strchr function

### See also

memchr | searches an array for the first occurrence of a character (function)
strrchr | finds the last occurrence of a character (function)
strpbrk | finds the first location of any character in one string, in another string (function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=c/string/byte/strchr&oldid=97202"